The SCSS Manual
***************

This manual describes the SCSS Scheme module.

   Copyright (C) 2007 Julian Graham.

     Permission is granted to copy, distribute and/or modify this
     document under the terms of the GNU Free Documentation License,
     Version 1.2 or any later version published by the Free Software
     Foundation; with no Invariant Sections, no Front-Cover Texts, and
     no Back-Cover Texts.  A copy of the license is included in the
     section entitled "GNU Free Documentation License".

Appendices

Indices

1 Introduction
**************

SCSS is an API for parsing and manipulating W3C Cascading Stylesheets
in the Scheme programming language. Although the majority of the W3C
recommendation is devoted to the proper rendering of documents styled
with CSS, SCSS concerns itself only with the formal structure of the
stylesheet itself - in other words, SCSS doesn't render anything! You
can however, combine SCSS with the XML parser of your choice (SCSS
integrates particularly well with SXML: http://ssax.sourceforge.net/ or
SDOM: http://www.nongnu.org/sdom/) to obtain style information about
your XML documents so that they may be rendered correctly.

   This document contains a desription of the SCSS API; for general
information about Cascading Stylesheets, see the W3C's CSS site
(http://www.w3.org/Style/CSS/).

2 Parsing and emitting style information
****************************************

 -- Function: scss:css->scss port
 -- Function: scss:css->scss port base-url
     Reads a complete stylesheet from PORT, verifying that it is
     well-formed and represents valid style information, and returns a
     Scheme-language representation of the stylesheet.  See SCSS stylesheet representation.
     Certain language elements not
     directly related to style information - such as comments - will be
     discarded during parsing, and @-rules will be evaluated and the
     results added to the resulting stylesheet.

     In particular, @import @-rules will cause SCSS to attempt to
     import the requested remote stylesheet into the one currently
     being parsed. SCSS understands relative and absolute filesystem
     paths as well as the "file://" URI scheme. (Use
     SCSS:SET-URI-IMPORT-HANDLER! to handle other URI schemes.)  As per
     the W3C recommendation, relatively-specified paths resolve
     relative to the location of the importing stylesheet. If the
     BASE-URL parameter is specified, it will be used as a base URI
     against which to resolve relative paths and URIs during the
     location of imported style documents.

     As part of parsing the stylesheet, this function will expand
     comma-delimited groups of selectors so that each selector refers
     internally to its own copy of the ruleset. This is optimization
     does not affect style queries, and can be reversed while emitting
     CSS-formatted style information from an SCSS stylesheet.

     Throws an error if the root stylesheet is either lexically or
     semantically invalid. Errors in imported stylesheets will be
     ignored.

 -- Function: scss:set-uri-import-handler! proc
     Install the procedure PROC as the handler to be called to retrieve
     data from an @import directive that specifies a URI for the remote
     stylesheet whose protocol is not "file://".  PROC should have the
     following signature:

          (lambda (uri) ...)

     ...where URI will be a string giving the original URI from the
     @import directive. PROC should return a valid input port from
     which the requested style information can be read. If PROC does
     not return a valid input port, the @import directive will be
     ignored and parsing will proceed normally.

 -- Function: scss:scss->css stylesheet port
     Sends a pretty-printed text representation of STYLESHEET to PORT.
     Throws an error if STYLESHEET is not a valid stylesheet as
     determined by SCSS:STYLESHEET?.

 -- Function: scss:create-cascade
 -- Function: scss:create-cascade user-sheet agent-sheet author-sheet
     Creates a new SCSS cascade, optionally initializing the three
     stylesheets to USER-SHEET, AGENT-SHEET, and AUTHOR-SHEET. If
     specified, these arguments must be valid SCSS stylesheets, as
     determined by SCSS:STYLESHEET?.

2.1 SCSS stylesheet representation
==================================

(Note that it is not necessary to understand the information in this
section to use the SCSS API. It is provided for users who curious about
how SCSS works or want to construct their own cascades or stylesheets
from scratch.)

   The full CSS cascade is represented in SCSS by a list containing
three items, each of these being an SCSS stylesheet object, ordered by
cascading precedence - that is, from left to right, the user agent's
stylesheet, the user's stylesheet, the author's stylesheet. If any part
of the cascade are missing, it is replaced with the empty list, (). So,
the SCSS of a cascade in which the author's stylesheet was missing
would look like:

     (USER-AGENT-STYLESHEET USER-STYLESHEET ())

   ...with USER-AGENT-STYLESHEET and USER-STYLESHEET replaced with SCSS
stylesheet expressions as follows.

   As of version 0.3, SCSS's stylesheet representation is based on the
format fully described in the documentation of Jim Bender's WebIt!
package (http://celtic.benderweb.net/webit/), and is outlined in brief
below. The S-expr stylesheet representations produced by SCSS are
wholly compatible with the ones used by WebIt!, provided that only
selector types and syntax from the CSS1 recommendation is used. Some
(externally incompatible) extensions to this format have been added, in
order to support CSS2.1; they are described at the end of this section.

   An SCSS stylesheet is a list, the head of which is the symbol CSS,
and the tail of which is a list of rules, each of which in turn
consists of a head element (a selector) and a tail of property-value
lists, each of which can be optionally wrapped in a list whose CAR is
!, the importance signifier.  The selector may be a symbol, a list of
symbols, or a composition of symbols and operators according the rules
set forth by the WebIt! specification. Each of the simple selector
types defined by the CSS recommendation has a short and an expanded
representation in the WebIt! format. The SCSS parser will produce the
short form when possible, but will fall back to the long form if an
unambiguous short form cannot be produced from the given input. The
following table gives the short and expanded forms of the selector
types SCSS has in common with WebIt!:

Selector type  Short form                    Expanded form
---------------------------------------------------------------------------
Class          SELECTOR.CLASS                '(class SELECTOR CLASS)
Pseudo-class   SELECTOR:CLASS                '(pclass SELECTOR CLASS)
ID             SELECTOR|#ID#                 '(id SELECTOR ID)

   Descendent path selectors are represented as a list of simple
selectors with the symbol // as its head.

   Two or more selectors can be grouped by making them into the
elements of a list.

   The following are extensions to the WebIt! format that have been
added to support the selector types and syntax introduced by CSS2.1:

   * Pseudo-element selectors. The short form is the same as that of
     the pseudo-class selectors, except that the name of the modifier
     must come from the CSS recommendation's list of valid
     pseudo-elements. The expanded form is also similar to that of a
     pseudo-class; the symbol in the CAR of the list must be PELEMENT.
     Examples:
          foo:first-line
          '(pelement foo before)

   * Attribute selectors. The short form is the literal selector, e.g.:
          foo[bar~=baz]
          foo[attrName]
     The long expanded syntax is a list of three elements, and has the
     form
          (attrib SUB-SELECTOR ATTRIB-EXPRESSION)
     ...where SUB-SELECTOR is the rest of this selector, in short or
     expanded form; and ATTRIB-EXPRESSION is either a symbol giving the
     attribute's name, meaning that no value is specified for the
     attribute selector, or a list with three elements, of the form
          (EQUALITY-OPERATOR ATTRIB-NAME ATTRIB-VALUE)
     ...where EQUALITY-OPERATOR is a symbol EQ to =, ~=, or |=;
     ATTRIB-NAME is a symbol; and ATTRIB-VALUE is a string. Examples of
     the extended syntax:
          '(attrib p q)
          '(attrib (pclass p r) (|= id "foo"))

   * Child and adjacent sibling selectors. These selectors have no
     short form. Their expanded form is a list giving the two subjects
     and the relationship operator in prefix notation:
          '(+ SELECTOR-A SELECTOR-B)
          '(> SELECTOR-A SELECTOR-B)
     ...where SELECTOR-A and SELECTOR-B are selectors in short or
     expanded form.

   * Media types. These are represented as "wrappers" around regular
     SCSS rulesets, and look like
          (@media MEDIA-TYPE-LIST RULESET)
     ...where MEDIA-TYPE-LIST is a list containing one or more symbols
     whose names are equal to the media type names from the CSS
     recommendation's list, and RULESET is a ruleset in SCSS's regular
     format. As per the CSS recommendation, media types do not nest.

   See the WebIt! documentation and the W3 CSS recommendation for more
information.

3 Style predicates
******************

 -- Function: scss:stylesheet? sheet
     Evaluates to #T if and only if SHEET is a valid result of parsing
     a stylesheet using SCSS:CSS->SCSS or has been constructed
     according to the SCSS format specification.  See SCSS stylesheet representation.

 -- Function: scss:cascade? cascade
     Evaluates to #T if and only if CASCADE is a list containing three
     elements, each of which is a valid stylesheet as evaluated by
     SCSS:STYLESHEET?.

 -- Function: scss:inherited? prop-name
     Evaluates to #T if and only if PROP-NAME is a string giving the
     name of a property that can be inherited from a parent node in a
     document tree.

4 Querying the cascade
**********************

 -- Function: scss:select-value cascade selector-str property
 -- Function: scss:select-value cascade selector-str medium property
 -- Function: scss:select-value cascade sxml-node sxml-doc property
 -- Function: scss:select-value cascade sxml-node sxml-doc medium
          property
     Retrieve a value for PROPERTY from the cascade represented by
     SOURCE, following the rules of precedence and inheritance set
     forth by the CSS recommendation. SOURCE must be a full cascade, as
     verified by SCSS:CASCADE?.

     The selector matching process proceeds according to the CSS
     recommendation - briefly put, matching properties from all
     matching selectors are retrieved, sorted by importance, then
     sorted by selector specificity. The head of this sorted list is
     the value returned.

     This function can be called with a string argument (SELECTOR-STR)
     to be used as the object against which to match a selector, or
     with an SXML document and SXML node within that document (SXML-DOC
     and SXML-NODE, respectively). Use of the SXML arguments is
     recommended, since SCSS cannot perform any of the richer matching
     mechanisms (such as XML attribute checks and inheritance) using
     only the string argument.

     If MEDIUM is specified (it should be a string, equal to one of the
     media types defined by the CSS2.1 recommendation), then it will be
     used to select among rulesets that specify a media type depending
     on whether MEDIUM matches the media type for a given ruleset. If
     MEDIUM is omitted, it will be taken to to be "all." See the CSS
     recommendation for more information.

     PROPERTY must be a string giving the name of the property to look
     up. If no value can be obtained through lookup and inheritance and
     PROPERTY is the name of a property defined in the CSS
     recommendation, SCSS will return the default value for that
     property.

 -- Function: scss:select-value-at-node cascade selector-str property
 -- Function: scss:select-value-at-node cascade selector-str medium
          property
 -- Function: scss:select-value-at-node cascade sxml-node sxml-doc
          property
 -- Function: scss:select-value-at-node cascade sxml-node sxml-doc
          medium property
     Similar to SCSS:SELECT-VALUE, but will not attempt to inherit a
     value for PROPERTY nor look up a default if no selectors can be
     matched to SXML-NODE or SELECTOR-STR. If the value of the property
     is available but is equal to "inherit," then the string "inherit"
     will be returned. Otherwise, an empty list will be returned.

 -- Function: scss:get-default-value prop-name
     Evaluates to the default value of the CSS property whose name is
     PROP-NAME. If PROP-NAME is not a valid property name, an empty
     list will be returned.

 -- Function: scss:clear-style-cache! cascade selector
 -- Function: scss:clear-style-cache! cascade selector sxml-doc
     Clears the internal caches of style information used by SCSS for
     repeat lookups on the CSS cascade given by CASCADE for the CSS
     selector SELECTOR. SCSS maintains a cache of text-only selector
     matches as well as per-document caches. The first form of this
     function should be used to clear the first type, in which case
     SELECTOR should be a string; the second to clear the per-document
     cache for the SXML document specified by SXML-DOC, in which case
     SELECTOR should be a node belonging to SXML-DOC. After the style
     cache has been cleared, a lookup that specifies SELECTOR as the
     target will cause a complete cascade lookup and re-caching to take
     place.

     SCSS hashes cascades based on applying the EQ? predicate to each
     of the component stylesheets. SCSS:CLEAR-STYLE-CACHE!  should be
     used when a change has been made to the contents of one of the
     component stylesheets in a cascade after the first lookup on a
     particular selector. An explicit cache-clearing mechanism is
     provided because the typical use case for SCSS does not include
     continual modification to style information in the cascade.

4.1 Specifying handlers for contextual style information
========================================================

Certain parts of CSS selector syntax cannot be handled directly by
SCSS, since they rely on contextual information from the user interface
in order to determine the outcome of a match attempt; others require
information that is dependent on the markup language. To properly match
these types of selectors, SCSS allows users to register handler
predicates that will be called when a match is being evaluated for a
selector that requires contextual information.

 -- Function: scss:set-dot-handler! proc
     Install the procedure PROC as the handler to be called to evaluate
     a match for a particular node against a selector using the "dot"
     syntax, the meaning of which is language-specific. In HTML, for
     example, a list of dot modifiers attached to a selector indicates
     that the node being matched must have an attribute named "class"
     whose value is a space-delimited list that is a superset of the
     dot modifiers on the selector. For this reason, PROC should have
     the signature:

          (lambda (str-list sxml-doc sxml-node) ...)

     ...where STR-LIST will be a list of strings, SXML-DOC will be the
     top of an SXML document, and SXML-NODE will be the SXML node for
     which a match is currently being evaluated. If PROC returns #F, the
     entire match for that selector will be rejected; otherwise it will
     proceed.

 -- Function: scss:set-id-handler! proc
     Install the procedure PROC as the handler to be called to evaluate
     a match for a particular node against a selector using the "#" ID
     syntax as defined in the XML Schema recommendation. The SXML
     specification does not provide a mechanism for recognizing ID
     elements, so it is up to the SCSS user to make the determination.
     PROC should have the following signature:

          (lambda (str sxml-doc sxml-node) ...)

     ...where STR will be a string giving the required value of the ID
     attribute, SXML-DOC will be the top of an SXML document, and
     SXML-NODE will be the SXML node for which a match is currently
     being evaluated. If PROC returns #F, the entire match for that
     selector will be rejected; otherwise it will proceed.

 -- Function: scss:set-pseudo-class-handler! proc
     Install the procedure PROC as the handler to be called to evaluate
     a match for a particular node against a selector that specifies a
     CSS pseudo-class for that element. PROC should have the following
     signature:

          (lambda (str sxml-doc sxml-node) ...)

     ...where STR will be a string giving the name of the required
     pseudo-class, SXML-DOC will be the top of an SXML document, and
     SXML-NODE will be the SXML node for which a match is currently
     being evaluated. If PROC returns #F, the entire match for that
     selector will be rejected; otherwise it will proceed. Note that
     SCSS is capable of recognizing a node matches the "first-child"
     pseudo-class on its own - in other cases, the handler will be
     called, with one of the following strings:

        * "link"

        * "visited"

        * "hover"

        * "active"

        * "focus"

        * "lang"

 -- Function: scss:set-pseudo-element-handler! proc
     Install the procedure PROC as the handler to be called to evaluate
     a match for a particular node against a selector that specifies a
     CSS pseudo-element child of that node.  PROC should have the
     following signature:

          (lambda (str sxml-doc sxml-node) ...)

     ...where STR will be a string giving the name of the required
     pseudo-class, SXML-DOC will be the top of an SXML document, and
     SXML-NODE will be the SXML node for which a match is currently
     being evaluated. If PROC returns #F, the entire match for that
     selector will be rejected; otherwise it will proceed. The handler
     will be called with one of the following strings:

        * "first-line"

        * "first-letter"

        * "before"

        * "after"

     Note that within the scope in which SCSS matches selectors to
     nodes, it is not possible for it to apply style to a subset of
     node content, so obtaining style information for pseudo-elements
     will not be straightforward. One half-solution you may wish to
     consider is creating an actual element to wrap the data contained
     by the pseudo-element and have your handler attempt to locate this
     element as a child of the node being matched. (Admittedly, this
     method defeats the purpose of pseudo-elements and may interfere
     with aspects of the matching process that rely on node hierarchy.)

4.2 Integration with SDOM
=========================

SCSS is well-suited to performing style queries on structural
information derived from pure SXML documents, but it can also be used
with documents that have been annotated for use with SDOM.  Note,
however, that certain types of SDOM nodes have two different
representations - an "internal" representation, which is the same as
the SXML representation of the node, and an "external" representation,
which is specific to SDOM. The reason these differences are important
is that SCSS needs to be able to determine the parent of a node within
a given document, and the method it uses by default is to search the
document for a child that matches according to the EQ? predicate, which
will incorrectly return #F when called on an external representation.

   As such, you should take care to make sure that SCSS can always
locate the parent of a node in your document. One way to do this is to
ensure that the node that you pass to SCSS matching functions is a
valid combination of CARs and CDRs from the document root. You may also
find the following function helpful:

 -- Function: scss:set-sxml-parent-function! proc
     Install the procedure PROC as the handler to be called to
     determine the parent of a node within an SXML-compliant document.
     PROC should have the following signature:

          (lambda (sxml-doc sxml-node) ...)

     ...and should return #F or the empty list () if SXML-DOC does not
     contain SXML-NODE or if SXML-NODE and SXML-DOC are the same node;
     otherwise it should return the node in the document that is the
     parent of SXML-NODE.

     For example, for nodes in an SDOM-compliant document, you may find
     the following procedure useful as a handler:

          (lambda (sxml-doc sxml-node)
            (sdom:get-dom-property sxml-node "sdom:parent-node"))

     See the SDOM documentation for more information.

5 Manipulating the cascade
**************************

 -- Function: scss:set-user-stylesheet! cascade stylesheet
     Set STYLESHEET as the "user" component of CASCADE.  STYLESHEET and
     CASCADE must be a valid stylesheet and a valid cascade, as
     determined by SCSS:STYLESHEET? and SCSS:CASCADE?, respectively.

 -- Function: scss:set-author-stylesheet! cascade stylesheet
     Set STYLESHEET as the "author" component of CASCADE. STYLESHEET
     and CASCADE must be a valid stylesheet and a valid cascade, as
     determined by SCSS:STYLESHEET? and SCSS:CASCADE?, respectively.

 -- Function: scss:set-agent-stylesheet! cascade stylesheet
     Set STYLESHEET as the "user agent" component of CASCADE.
     STYLESHEET and CASCADE must be a valid stylesheet and a valid
     cascade, as determined by SCSS:STYLESHEET? and SCSS:CASCADE?,
     respectively.

6 Utility functions
*******************

The following functions are not directly related to the style cascade
but may be useful to developers working with style information.

 -- Function: scss:color->hex color
     Evaluates to a string representation of a hexadecimal number
     corresponding to the string given by COLOR, if COLOR is one of
     "maroon," "red," "orange," "yellow," "olive," "purple," "fuschia,"
     "white," "lime," "green," "navy," "blue," "aqua," "teal," "black,"
     "silver," or "gray;" otherwise, the empty list.

Appendix A GNU Free Documentation License
*****************************************

                      Version 1.2, November 2002

     Copyright (C) 2000,2001,2002 Free Software Foundation, Inc.
     51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA

     Everyone is permitted to copy and distribute verbatim copies
     of this license document, but changing it is not allowed.

  0. PREAMBLE

     The purpose of this License is to make a manual, textbook, or other
     functional and useful document "free" in the sense of freedom: to
     assure everyone the effective freedom to copy and redistribute it,
     with or without modifying it, either commercially or
     noncommercially.  Secondarily, this License preserves for the
     author and publisher a way to get credit for their work, while not
     being considered responsible for modifications made by others.

     This License is a kind of "copyleft", which means that derivative
     works of the document must themselves be free in the same sense.
     It complements the GNU General Public License, which is a copyleft
     license designed for free software.

     We have designed this License in order to use it for manuals for
     free software, because free software needs free documentation: a
     free program should come with manuals providing the same freedoms
     that the software does.  But this License is not limited to
     software manuals; it can be used for any textual work, regardless
     of subject matter or whether it is published as a printed book.
     We recommend this License principally for works whose purpose is
     instruction or reference.

  1. APPLICABILITY AND DEFINITIONS

     This License applies to any manual or other work, in any medium,
     that contains a notice placed by the copyright holder saying it
     can be distributed under the terms of this License.  Such a notice
     grants a world-wide, royalty-free license, unlimited in duration,
     to use that work under the conditions stated herein.  The
     "Document", below, refers to any such manual or work.  Any member
     of the public is a licensee, and is addressed as "you".  You
     accept the license if you copy, modify or distribute the work in a
     way requiring permission under copyright law.

     A "Modified Version" of the Document means any work containing the
     Document or a portion of it, either copied verbatim, or with
     modifications and/or translated into another language.

     A "Secondary Section" is a named appendix or a front-matter section
     of the Document that deals exclusively with the relationship of the
     publishers or authors of the Document to the Document's overall
     subject (or to related matters) and contains nothing that could
     fall directly within that overall subject.  (Thus, if the Document
     is in part a textbook of mathematics, a Secondary Section may not
     explain any mathematics.)  The relationship could be a matter of
     historical connection with the subject or with related matters, or
     of legal, commercial, philosophical, ethical or political position
     regarding them.

     The "Invariant Sections" are certain Secondary Sections whose
     titles are designated, as being those of Invariant Sections, in
     the notice that says that the Document is released under this
     License.  If a section does not fit the above definition of
     Secondary then it is not allowed to be designated as Invariant.
     The Document may contain zero Invariant Sections.  If the Document
     does not identify any Invariant Sections then there are none.

     The "Cover Texts" are certain short passages of text that are
     listed, as Front-Cover Texts or Back-Cover Texts, in the notice
     that says that the Document is released under this License.  A
     Front-Cover Text may be at most 5 words, and a Back-Cover Text may
     be at most 25 words.

     A "Transparent" copy of the Document means a machine-readable copy,
     represented in a format whose specification is available to the
     general public, that is suitable for revising the document
     straightforwardly with generic text editors or (for images
     composed of pixels) generic paint programs or (for drawings) some
     widely available drawing editor, and that is suitable for input to
     text formatters or for automatic translation to a variety of
     formats suitable for input to text formatters.  A copy made in an
     otherwise Transparent file format whose markup, or absence of
     markup, has been arranged to thwart or discourage subsequent
     modification by readers is not Transparent.  An image format is
     not Transparent if used for any substantial amount of text.  A
     copy that is not "Transparent" is called "Opaque".

     Examples of suitable formats for Transparent copies include plain
     ASCII without markup, Texinfo input format, LaTeX input format,
     SGML or XML using a publicly available DTD, and
     standard-conforming simple HTML, PostScript or PDF designed for
     human modification.  Examples of transparent image formats include
     PNG, XCF and JPG.  Opaque formats include proprietary formats that
     can be read and edited only by proprietary word processors, SGML or
     XML for which the DTD and/or processing tools are not generally
     available, and the machine-generated HTML, PostScript or PDF
     produced by some word processors for output purposes only.

     The "Title Page" means, for a printed book, the title page itself,
     plus such following pages as are needed to hold, legibly, the
     material this License requires to appear in the title page.  For
     works in formats which do not have any title page as such, "Title
     Page" means the text near the most prominent appearance of the
     work's title, preceding the beginning of the body of the text.

     A section "Entitled XYZ" means a named subunit of the Document
     whose title either is precisely XYZ or contains XYZ in parentheses
     following text that translates XYZ in another language.  (Here XYZ
     stands for a specific section name mentioned below, such as
     "Acknowledgements", "Dedications", "Endorsements", or "History".)
     To "Preserve the Title" of such a section when you modify the
     Document means that it remains a section "Entitled XYZ" according
     to this definition.

     The Document may include Warranty Disclaimers next to the notice
     which states that this License applies to the Document.  These
     Warranty Disclaimers are considered to be included by reference in
     this License, but only as regards disclaiming warranties: any other
     implication that these Warranty Disclaimers may have is void and
     has no effect on the meaning of this License.

  2. VERBATIM COPYING

     You may copy and distribute the Document in any medium, either
     commercially or noncommercially, provided that this License, the
     copyright notices, and the license notice saying this License
     applies to the Document are reproduced in all copies, and that you
     add no other conditions whatsoever to those of this License.  You
     may not use technical measures to obstruct or control the reading
     or further copying of the copies you make or distribute.  However,
     you may accept compensation in exchange for copies.  If you
     distribute a large enough number of copies you must also follow
     the conditions in section 3.

     You may also lend copies, under the same conditions stated above,
     and you may publicly display copies.

  3. COPYING IN QUANTITY

     If you publish printed copies (or copies in media that commonly
     have printed covers) of the Document, numbering more than 100, and
     the Document's license notice requires Cover Texts, you must
     enclose the copies in covers that carry, clearly and legibly, all
     these Cover Texts: Front-Cover Texts on the front cover, and
     Back-Cover Texts on the back cover.  Both covers must also clearly
     and legibly identify you as the publisher of these copies.  The
     front cover must present the full title with all words of the
     title equally prominent and visible.  You may add other material
     on the covers in addition.  Copying with changes limited to the
     covers, as long as they preserve the title of the Document and
     satisfy these conditions, can be treated as verbatim copying in
     other respects.

     If the required texts for either cover are too voluminous to fit
     legibly, you should put the first ones listed (as many as fit
     reasonably) on the actual cover, and continue the rest onto
     adjacent pages.

     If you publish or distribute Opaque copies of the Document
     numbering more than 100, you must either include a
     machine-readable Transparent copy along with each Opaque copy, or
     state in or with each Opaque copy a computer-network location from
     which the general network-using public has access to download
     using public-standard network protocols a complete Transparent
     copy of the Document, free of added material.  If you use the
     latter option, you must take reasonably prudent steps, when you
     begin distribution of Opaque copies in quantity, to ensure that
     this Transparent copy will remain thus accessible at the stated
     location until at least one year after the last time you
     distribute an Opaque copy (directly or through your agents or
     retailers) of that edition to the public.

     It is requested, but not required, that you contact the authors of
     the Document well before redistributing any large number of
     copies, to give them a chance to provide you with an updated
     version of the Document.

  4. MODIFICATIONS

     You may copy and distribute a Modified Version of the Document
     under the conditions of sections 2 and 3 above, provided that you
     release the Modified Version under precisely this License, with
     the Modified Version filling the role of the Document, thus
     licensing distribution and modification of the Modified Version to
     whoever possesses a copy of it.  In addition, you must do these
     things in the Modified Version:

       A. Use in the Title Page (and on the covers, if any) a title
          distinct from that of the Document, and from those of
          previous versions (which should, if there were any, be listed
          in the History section of the Document).  You may use the
          same title as a previous version if the original publisher of
          that version gives permission.

       B. List on the Title Page, as authors, one or more persons or
          entities responsible for authorship of the modifications in
          the Modified Version, together with at least five of the
          principal authors of the Document (all of its principal
          authors, if it has fewer than five), unless they release you
          from this requirement.

       C. State on the Title page the name of the publisher of the
          Modified Version, as the publisher.

       D. Preserve all the copyright notices of the Document.

       E. Add an appropriate copyright notice for your modifications
          adjacent to the other copyright notices.

       F. Include, immediately after the copyright notices, a license
          notice giving the public permission to use the Modified
          Version under the terms of this License, in the form shown in
          the Addendum below.

       G. Preserve in that license notice the full lists of Invariant
          Sections and required Cover Texts given in the Document's
          license notice.

       H. Include an unaltered copy of this License.

       I. Preserve the section Entitled "History", Preserve its Title,
          and add to it an item stating at least the title, year, new
          authors, and publisher of the Modified Version as given on
          the Title Page.  If there is no section Entitled "History" in
          the Document, create one stating the title, year, authors,
          and publisher of the Document as given on its Title Page,
          then add an item describing the Modified Version as stated in
          the previous sentence.

       J. Preserve the network location, if any, given in the Document
          for public access to a Transparent copy of the Document, and
          likewise the network locations given in the Document for
          previous versions it was based on.  These may be placed in
          the "History" section.  You may omit a network location for a
          work that was published at least four years before the
          Document itself, or if the original publisher of the version
          it refers to gives permission.

       K. For any section Entitled "Acknowledgements" or "Dedications",
          Preserve the Title of the section, and preserve in the
          section all the substance and tone of each of the contributor
          acknowledgements and/or dedications given therein.

       L. Preserve all the Invariant Sections of the Document,
          unaltered in their text and in their titles.  Section numbers
          or the equivalent are not considered part of the section
          titles.

       M. Delete any section Entitled "Endorsements".  Such a section
          may not be included in the Modified Version.

       N. Do not retitle any existing section to be Entitled
          "Endorsements" or to conflict in title with any Invariant
          Section.

       O. Preserve any Warranty Disclaimers.

     If the Modified Version includes new front-matter sections or
     appendices that qualify as Secondary Sections and contain no
     material copied from the Document, you may at your option
     designate some or all of these sections as invariant.  To do this,
     add their titles to the list of Invariant Sections in the Modified
     Version's license notice.  These titles must be distinct from any
     other section titles.

     You may add a section Entitled "Endorsements", provided it contains
     nothing but endorsements of your Modified Version by various
     parties--for example, statements of peer review or that the text
     has been approved by an organization as the authoritative
     definition of a standard.

     You may add a passage of up to five words as a Front-Cover Text,
     and a passage of up to 25 words as a Back-Cover Text, to the end
     of the list of Cover Texts in the Modified Version.  Only one
     passage of Front-Cover Text and one of Back-Cover Text may be
     added by (or through arrangements made by) any one entity.  If the
     Document already includes a cover text for the same cover,
     previously added by you or by arrangement made by the same entity
     you are acting on behalf of, you may not add another; but you may
     replace the old one, on explicit permission from the previous
     publisher that added the old one.

     The author(s) and publisher(s) of the Document do not by this
     License give permission to use their names for publicity for or to
     assert or imply endorsement of any Modified Version.

  5. COMBINING DOCUMENTS

     You may combine the Document with other documents released under
     this License, under the terms defined in section 4 above for
     modified versions, provided that you include in the combination
     all of the Invariant Sections of all of the original documents,
     unmodified, and list them all as Invariant Sections of your
     combined work in its license notice, and that you preserve all
     their Warranty Disclaimers.

     The combined work need only contain one copy of this License, and
     multiple identical Invariant Sections may be replaced with a single
     copy.  If there are multiple Invariant Sections with the same name
     but different contents, make the title of each such section unique
     by adding at the end of it, in parentheses, the name of the
     original author or publisher of that section if known, or else a
     unique number.  Make the same adjustment to the section titles in
     the list of Invariant Sections in the license notice of the
     combined work.

     In the combination, you must combine any sections Entitled
     "History" in the various original documents, forming one section
     Entitled "History"; likewise combine any sections Entitled
     "Acknowledgements", and any sections Entitled "Dedications".  You
     must delete all sections Entitled "Endorsements."

  6. COLLECTIONS OF DOCUMENTS

     You may make a collection consisting of the Document and other
     documents released under this License, and replace the individual
     copies of this License in the various documents with a single copy
     that is included in the collection, provided that you follow the
     rules of this License for verbatim copying of each of the
     documents in all other respects.

     You may extract a single document from such a collection, and
     distribute it individually under this License, provided you insert
     a copy of this License into the extracted document, and follow
     this License in all other respects regarding verbatim copying of
     that document.

  7. AGGREGATION WITH INDEPENDENT WORKS

     A compilation of the Document or its derivatives with other
     separate and independent documents or works, in or on a volume of
     a storage or distribution medium, is called an "aggregate" if the
     copyright resulting from the compilation is not used to limit the
     legal rights of the compilation's users beyond what the individual
     works permit.  When the Document is included in an aggregate, this
     License does not apply to the other works in the aggregate which
     are not themselves derivative works of the Document.

     If the Cover Text requirement of section 3 is applicable to these
     copies of the Document, then if the Document is less than one half
     of the entire aggregate, the Document's Cover Texts may be placed
     on covers that bracket the Document within the aggregate, or the
     electronic equivalent of covers if the Document is in electronic
     form.  Otherwise they must appear on printed covers that bracket
     the whole aggregate.

  8. TRANSLATION

     Translation is considered a kind of modification, so you may
     distribute translations of the Document under the terms of section
     4.  Replacing Invariant Sections with translations requires special
     permission from their copyright holders, but you may include
     translations of some or all Invariant Sections in addition to the
     original versions of these Invariant Sections.  You may include a
     translation of this License, and all the license notices in the
     Document, and any Warranty Disclaimers, provided that you also
     include the original English version of this License and the
     original versions of those notices and disclaimers.  In case of a
     disagreement between the translation and the original version of
     this License or a notice or disclaimer, the original version will
     prevail.

     If a section in the Document is Entitled "Acknowledgements",
     "Dedications", or "History", the requirement (section 4) to
     Preserve its Title (section 1) will typically require changing the
     actual title.

  9. TERMINATION

     You may not copy, modify, sublicense, or distribute the Document
     except as expressly provided for under this License.  Any other
     attempt to copy, modify, sublicense or distribute the Document is
     void, and will automatically terminate your rights under this
     License.  However, parties who have received copies, or rights,
     from you under this License will not have their licenses
     terminated so long as such parties remain in full compliance.

 10. FUTURE REVISIONS OF THIS LICENSE

     The Free Software Foundation may publish new, revised versions of
     the GNU Free Documentation License from time to time.  Such new
     versions will be similar in spirit to the present version, but may
     differ in detail to address new problems or concerns.  See
     `http://www.gnu.org/copyleft/'.

     Each version of the License is given a distinguishing version
     number.  If the Document specifies that a particular numbered
     version of this License "or any later version" applies to it, you
     have the option of following the terms and conditions either of
     that specified version or of any later version that has been
     published (not as a draft) by the Free Software Foundation.  If
     the Document does not specify a version number of this License,
     you may choose any version ever published (not as a draft) by the
     Free Software Foundation.

A.0.1 ADDENDUM: How to use this License for your documents
----------------------------------------------------------

To use this License in a document you have written, include a copy of
the License in the document and put the following copyright and license
notices just after the title page:

       Copyright (C)  YEAR  YOUR NAME.
       Permission is granted to copy, distribute and/or modify this document
       under the terms of the GNU Free Documentation License, Version 1.2
       or any later version published by the Free Software Foundation;
       with no Invariant Sections, no Front-Cover Texts, and no Back-Cover
       Texts.  A copy of the license is included in the section entitled ``GNU
       Free Documentation License''.

   If you have Invariant Sections, Front-Cover Texts and Back-Cover
Texts, replace the "with...Texts." line with this:

         with the Invariant Sections being LIST THEIR TITLES, with
         the Front-Cover Texts being LIST, and with the Back-Cover Texts
         being LIST.

   If you have Invariant Sections without Cover Texts, or some other
combination of the three, merge those two alternatives to suit the
situation.

   If your document contains nontrivial examples of program code, we
recommend releasing these examples in parallel under your choice of
free software license, such as the GNU General Public License, to
permit their use in free software.